//
//  DeVercruesseProcess.h
//
//  Created by Frank Vercruesse on Wed Apr 04 2001.
//  Copyright (c) 2001 Frank Vercruesse.
//
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
//  02111-1307, USA.

#import <Cocoa/Cocoa.h>
#import <Carbon/Carbon.h>
#import "CPS.h"


@interface DeVercruesseProcess : NSObject
{
    ProcessSerialNumber	psn;
    
    UInt32		pid,
                        flavour,
                        attributes,
                        type,
                        creator;
    
    NSString		*bundleIdentifier;
    NSString		*identifier;
    NSString		*loc;
    NSString		*name;
    NSImage		*img;
    NSImage		*cachedImage;
}

+ (id)processWithPSN:(ProcessSerialNumber*)sn;

- (id)initWithPSN:(ProcessSerialNumber*)sn;

- (NSString *)executableLoc;
- (NSString*)loc;
- (NSString*)name;
- (NSImage*)img;
- (NSImage *)cachedImage;
- (void)setCachedImage:(NSImage *)anImage;

- (ProcessSerialNumber*)psn;
- (UInt32)pid;
- (UInt32)flavour;
- (UInt32)attributes;
- (UInt32)type;
- (UInt32)creator;
- (NSString*)bundleIdentifier;
- (NSString*)identifier;

- (BOOL)isEqualToCurrent;
- (BOOL)isEqualToFront;

- (BOOL)isStillRunning;

- (BOOL)isBackgroundOnly;
- (BOOL)isHidden;

- (BOOL)isClassic;
- (BOOL)isCarbon;
- (BOOL)isCocoa;

- (void)show;
- (void)hide;

- (void)makeFront;

- (void)kill;
- (void)kill:(BOOL)hard;

@end
